// Includes
#include <3ds.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

// titlescreen.jpg from data folder
#include "titlescreen_jpg.h"

#include"gba-jpeg-decode.h"

#define w (400)
#define h (240)
u16 * buff;

void drawScreen(){

    u8* bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    
	int i, j;
    for(i=1;i<w;i++)
	{
		for(j=1;j<h;j++)
		{
            u32 v=(j+i*240)*3;
            bufAdr[v]=buff[i+w*j];
            bufAdr[v+1]=buff[i+w*j];
            bufAdr[v+2]=buff[i+w*j];
        }
	}
}


// Function: main()
int main(int argc, char ** argv)
{
	//initialize the services we're going to be using
	srvInit(); //needed for everything
	aptInit(); //needed for everything
	hidInit(NULL); //needed for input
	gfxInit(); //makes displaying to screen easier
	fsInit(); //needed for filesystem stuff
    //gfxSet3D(true);
    
	//u16* output = (u16*)(0x06000000);

	JPEG_DecompressImage(titlescreen_jpg, buff, 256, 192);
    
        
    // Infinite loop to keep the program running
	while (1)
	{
		//exit when user hits B
		hidScanInput();
		if(keysHeld()&KEY_B)break;

        drawScreen();

		//copy buffer to lower screen (don't have to do it every frame)
		//memcpy(gfxGetFramebuffer(GFX_BOTTOM, GFX_BOTTOM, NULL, NULL), buffer, size);
        
        
		//wait & swap
		gfxSwapBuffersGpu();
        gspWaitForEvent(GSPEVENT_VBlank0, false);
	}
	
    
	//closing all services even more so
	gfxExit();
	hidExit();
	aptExit();
	srvExit();
	return 0;
} // End of main()

